<?xml version="1.0"?>
<!--@+leo-->

<!--@+node:0::@file sbx_pic.xsl-->
<!--@+body-->
<!--@@first <?xml version="1.0"?>-->
<!--@@language html-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" indent="yes"/>

<xsl:variable name="pageCount" select="count(/screenbook/pages/page)"/>

<!--@<< main template >>-->
<!--@+node:1::<< main template >>-->
<!--@+body-->
<!--@@code-->

<xsl:template match="/">

<files>

  <xsl:for-each select="screenbook/pages/page">
  
    <file>

      <html>
        
<!--@<< head >>-->
		<!--@+node:1::<< head >>-->
		<!--@+body-->
		<!--@@code-->
		  
		<head>
		  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/> 
		  <meta name="keywords" content="{../../keywords}" />
		  <meta name="description" content="{../../description}"/>
		  <title>
		  <xsl:value-of select="../../title"/> : <xsl:value-of select="title"/>
		  </title>
		  <link rel='stylesheet' type='text/css' href='../../../../sbook1.css'/>
		  <script src='../../../../sbook.js'></script>
		  <script>init2()</script>
		  <style type="text/css">
			BODY {margin-top:0}
		  </style>
		 </head>
		<!--@-body-->
		<!--@-node:1::<< head >>-->

	    
<!--@<< body >>-->
		<!--@+node:2::<< body >>-->
		<!--@+body-->
		<!--@@code-->
		
		
		<!--@<< layer 1 >>-->
		<!--@+node:1::<< layer 1 >>-->
		<!--@+body-->
		<!--@@code-->
		
		    <div id='Layer1' style='position:absolute; width:180px; height:30px; z-index:2; left: 10x; top: 1px'> 
		    <table>
		      <tr>
		      <td>
		      <a>
			  <xsl:attribute name='href'>sbook2.htm#<xsl:value-of select="position()"/></xsl:attribute><font size="2">Back To Screenbook</font></a>    
			  </td>
			  </tr>
			</table>  
			</div>
		

		<!--@-body-->
		<!--@-node:1::<< layer 1 >>-->

		
		<!--@<< layer 2 >>-->
		<!--@+node:2::<< layer 2 >>-->
		<!--@+body-->
		<!--@+doc-->
		<!--
		
		
		The title bar.
		

		-->

		<!--@-doc-->
		<!--@@code-->
		
		<div id='Layer2' class="layer2"> 
		  <table width='660' border='0' align='left' bgcolor='#999999'>
		    <tr>
		    <td class='txt2'>&#160;
		    <span class='txt1'>&#160;<xsl:value-of select="/screenbook/category"/> : <xsl:value-of select="/screenbook/subcategory"/></span>
		    <span class='txt3'>&#160; &#160;<xsl:value-of select="/screenbook/title"/></span> &#160;
		    </td>
		    </tr>
		  </table>
		</div>
		<!--@-body-->
		<!--@-node:2::<< layer 2 >>-->

		
		<!--@<< layer 3 >>-->
		<!--@+node:3::<< layer 3 >>-->
		<!--@+body-->
		<!--@@code-->
		
		    <div id='Layer3' style='position:absolute; width:600px; z-index:2; left: 10px; top: 60px'> 
		      
		      <xsl:call-template name="screenbookImage">
		        <xsl:with-param name="pic" select="picture"/>
		      </xsl:call-template>     
		
		      <map name="map1"><area shape="rect" coords="425,0 585,14" href="http://www.screenbooks.net" alt="screenbooks home site" /></map>
		      <hr align='left' class='hr1' />
		
		      <xsl:call-template name="copyright">
		        <xsl:with-param name="page" select="."/>
		      </xsl:call-template>
		    
			</div>

		<!--@-body-->
		<!--@-node:3::<< layer 3 >>-->


		<!--@-body-->
		<!--@-node:2::<< body >>-->

      </html>
  
    </file>

  </xsl:for-each>
</files>

</xsl:template>
<!--@-body-->
<!--@-node:1::<< main template >>-->


<!--@<< call-templates >>-->
<!--@+node:2::<< call-templates >>-->
<!--@+body-->
<!--@@code-->


<!--@<< image 1 >>-->
<!--@+node:1::<< image 1 >>-->
<!--@+body-->
<!--@@code-->

<xsl:template name="screenbookImage">
  <xsl:param name="pic"/>
  <xsl:choose>
  <xsl:when test="$pic='[Empty]'">
  </xsl:when>  
  <xsl:otherwise>
    <img border="0" src="{$pic}" width="{$pic/@width}" height="{$pic/@height}" class="image1" ismap="ismap" usemap="#map1" />
  </xsl:otherwise>
  </xsl:choose>
</xsl:template>
<!--@-body-->
<!--@-node:1::<< image 1 >>-->


<!--@<< copyright >>-->
<!--@+node:2::<< copyright >>-->
<!--@+body-->
<!--@@code-->

<xsl:template name="copyright">
  <xsl:param name="page"/>

  <xsl:if test="$page/text != '[Empty]'">
    <span class='cp'>Text Author: <xsl:value-of select="$page/author"/></span> &#160;  
  </xsl:if>
  <xsl:if test="$page/cp != '[Empty]'">
    <span class='cp'><xsl:value-of select="$page/cp"/></span> &#160;  
  </xsl:if>
  <xsl:if test="$page/sauthor != '[Empty]'">
    <span class='cp'>Screenshot By: <xsl:value-of select="$page/sauthor"/></span> &#160;  
  </xsl:if>
</xsl:template>
<!--@-body-->
<!--@-node:2::<< copyright >>-->


<!--@<< slide name >>-->
<!--@+node:3::<< slide name >>-->
<!--@+body-->
<!--@@code-->

<xsl:template name="slideName">
  <xsl:param name="myIndex"/>
  <xsl:text>slide</xsl:text>
  <xsl:choose>
  <xsl:when test="$myIndex &lt; 10">0</xsl:when>
  <xsl:otherwise>
  </xsl:otherwise>
  </xsl:choose>
  <xsl:value-of select="$myIndex"/>
  <xsl:text>.htm</xsl:text>
</xsl:template>
<!--@-body-->
<!--@-node:3::<< slide name >>-->
<!--@-body-->
<!--@-node:2::<< call-templates >>-->

</xsl:stylesheet>
<!--@-body-->
<!--@-node:0::@file sbx_pic.xsl-->
<!--@-leo-->