<?xml version="1.0"?>
<!--@+leo-->

<!--@+node:0::@file sbx_sbook2.xsl-->
<!--@+body-->
<!--@@first <?xml version="1.0"?>-->
<!--@@language html-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" indent="yes"/>

<xsl:variable name="pageCount" select="count(/screenbook/pages/page)"/>

<!--@<< main template >>-->
<!--@+node:1::<< main template >>-->
<!--@+body-->
<!--@@code-->

<xsl:template match="/">

  <html>
    
<!--@<< head >>-->
	<!--@+node:1::<< head >>-->
	<!--@+body-->
	<!--@@code-->
	  
	<head>
	  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/> 
	  <meta name="keywords" content="{../../keywords}" />
	  <meta name="description" content="{../../description}"/>
	  <title>
	  <xsl:value-of select="../../title"/> : <xsl:value-of select="title"/>
	  </title>
	  <link rel='stylesheet' type='text/css' href='../../../../sbook1.css'/>
	  <script src='../../../../sbook.js'></script>
	  <script>init2()</script>
	  <style type="text/css">
		BODY {margin-top:0}
	  </style>
	 </head>
	<!--@-body-->
	<!--@-node:1::<< head >>-->

    
<!--@<< body >>-->
	<!--@+node:2::<< body >>-->
	<!--@+body-->
	<!--@@code-->
	
	
	<!--@<< layer 1 >>-->
	<!--@+node:1::<< layer 1 >>-->
	<!--@+body-->
	<!--@@code-->
	
	<xsl:variable name="myIndex"><xsl:if test="position() &lt; 10">0</xsl:if><xsl:value-of select="position()"/></xsl:variable>
	
	<div id='Layer1' style='position:absolute; width:180px; height:30px; z-index:2; left: 10x; top: 1px'> 
	  <table>
	  <tr>
	      <td width='56' nowrap="nowrap" class='navbar'>
	      <a  title='Table of contents of this Bookshelf (No Frames)' href="javascript:go('../../../../sbooktoc.htm')"><img src='../../../../books.gif' border='0' hspace='2' width='12px' height='14px'/></a><xsl:text>
	      </xsl:text>
	      <a title='Table of contents of this Bookshelf (Frames)'>
		  <xsl:attribute name="href">javascript:go('sbframetoc.htm?f=slide<xsl:value-of select="$myIndex"/>.htm')</xsl:attribute>
		  <img src='../../../../bwind.gif' border='0' hspace='3' width='12px' height='14px' /></a><xsl:text>
		  </xsl:text>
	      </td>
	    <td width='40' nowrap="nowrap" class='navbar' title='Search this bookshelf'>
	      <a href='../../../../search.htm' target='_top'><img src='../../../../search.gif' width='18' height='14' border='0' /></a>
	    </td>
	    <td width='20' nowrap="nowrap" class='navbar' title='View this page with no frames'>
	      <a href='sbook.htm' target='_top'><img src='../../../../window.gif' border='0' hspace='2' width='30px' height='14px' /></a>
	    </td>
	  </tr>
	  </table>
	</div>
	<!--@-body-->
	<!--@-node:1::<< layer 1 >>-->

	
	<!--@<< layer 2 >>-->
	<!--@+node:2::<< layer 2 >>-->
	<!--@+body-->
	<!--@+doc-->
	<!--
	
	
	The title bar.
	

	-->

	<!--@-doc-->
	<!--@@code-->
	
	<div id='Layer2' class="layer2"> 
	  <table width='660' border='0' align='left' bgcolor='#999999'>
	    <tr>
	    <td class='txt2'>&#160;
	    <span class='txt1'>&#160;<xsl:value-of select="/screenbook/category"/> : <xsl:value-of select="/screenbook/subcategory"/></span>
	    <span class='txt3'>&#160; &#160;<xsl:value-of select="/screenbook/title"/></span> &#160;
	    </td>
	    </tr>
	  </table>
	</div>
	<!--@-body-->
	<!--@-node:2::<< layer 2 >>-->

	
	<!--@<< layer 3 >>-->
	<!--@+node:3::<< layer 3 >>-->
	<!--@+body-->
	<!--@@code-->
	
	<div id='Layer3' style='position:absolute; width:600px; z-index:2; left:10px; top:60px'> 
	
	<xsl:for-each select="/screenbook/pages/page">
	  <xsl:value-of select="text" disable-output-escaping="yes"/>
	  <div class='br1'> &#160; </div>
	  <xsl:call-template name="screenbookImage">
	    <xsl:with-param name="pic" select="picture"/>
	  </xsl:call-template> 
	  <br/>
	  <hr class='hr1'/>
	</xsl:for-each>
	
	<xsl:call-template name="copyright">
	  <xsl:with-param name="page" select="/screenbook/pages/page[1]"/>
	</xsl:call-template>
	
	</div>
	<!--@-body-->
	<!--@-node:3::<< layer 3 >>-->
	<!--@-body-->
	<!--@-node:2::<< body >>-->

  </html>
  
</xsl:template>
<!--@-body-->
<!--@-node:1::<< main template >>-->


<!--@<< call-templates >>-->
<!--@+node:2::<< call-templates >>-->
<!--@+body-->
<!--@@code-->


<!--@<< image 1 >>-->
<!--@+node:1::<< image 1 >>-->
<!--@+body-->
<!--@@code-->

<xsl:template name="screenbookImage">
  <xsl:param name="pic"/>
  <xsl:choose>
  <xsl:when test="$pic='[Empty]'">
  </xsl:when>  
  <xsl:otherwise>
    <a>
	<xsl:attribute name="href">
	  <xsl:text>pic</xsl:text><xsl:if test="position() &lt; 10">0</xsl:if><xsl:value-of select="position()"/><xsl:text>.htm</xsl:text>
	</xsl:attribute>
	<img border="0" src="../../../../screen.png" width="11" height="12" />
    </a>
  </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<!--@-body-->
<!--@-node:1::<< image 1 >>-->


<!--@<< copyright >>-->
<!--@+node:2::<< copyright >>-->
<!--@+body-->
<!--@@code-->

<xsl:template name="copyright">
  <xsl:param name="page"/>

  <xsl:if test="$page/text != '[Empty]' and $page/author != '[Empty]'">
    <span class='cp'>Text Author: <xsl:value-of select="$page/author"/></span> &#160;  
  </xsl:if>
  <xsl:if test="$page/cp != '[Empty]'">
    <span class='cp'><xsl:value-of select="$page/cp"/></span> &#160;  
  </xsl:if>
  <xsl:if test="$page/sauthor != '[Empty]'">
    <span class='cp'>Screenshot By: <xsl:value-of select="$page/sauthor"/></span> &#160;  
  </xsl:if>
</xsl:template>
<!--@-body-->
<!--@-node:2::<< copyright >>-->
<!--@-body-->
<!--@-node:2::<< call-templates >>-->

</xsl:stylesheet>
<!--@-body-->
<!--@-node:0::@file sbx_sbook2.xsl-->
<!--@-leo-->